> ## Documentation Index
> Fetch the complete documentation index at: https://ona.com/docs/llms.txt
> Use this file to discover all available pages before exploring further.

# List Team Members

> Lists members of a team with optional pagination.

`Unary` · [`Teams`](/docs/api-reference/generated/team/overview)

Lists members of a team with optional pagination.

Use this method to:

* View all members of a team

### Examples

* List team members:

  ```yaml theme={null}
  teamId: "d2c94c27-3b76-4a42-b88c-95a85e392c68"
  pagination:
    pageSize: 20
  ```

### Authorization

Requires `teammembership:read` permission on the team.

## Endpoint

```text theme={null}
POST /api/gitpod.v1.TeamService/ListTeamMembers
```

Send a Bearer token as described in [Authentication](/docs/api-reference#authenticate-requests). If your organization uses a custom management-plane domain, replace `https://app.ona.com` with that domain.

## Request example

<CodeGroup>
  ```bash cURL theme={null}
  export ONA_HOST=https://app.ona.com
  export ONA_API_KEY=<your-token>

  curl --request POST \
    --url "$ONA_HOST/api/gitpod.v1.TeamService/ListTeamMembers" \
    --header "Authorization: Bearer $ONA_API_KEY" \
    --header "Content-Type: application/json" \
    --data '{
    "pagination": {
      "pageSize": 1
    }
  }'
  ```

  ```python Python theme={null}
  import gitpod.v1.pagination_pb2 as pagination_pb2
  import gitpod.v1.team_pb2 as team_pb2
  from ona_sdk import create_client_from_env

  ona = create_client_from_env()
  request = team_pb2.ListTeamMembersRequest(
      pagination=pagination_pb2.PaginationRequest(
          page_size=1,
      ),
  )
  response = ona.services.team.list_team_members(request)
  print(response)
  ```

  ```typescript TypeScript theme={null}
  import { create } from "@bufbuild/protobuf";
  import { createClientFromEnv } from "@gitpod/sdk";
  import { ListTeamMembersRequestSchema } from "@gitpod/sdk/gitpod/v1/team_pb";

  async function main() {
    const ona = createClientFromEnv();
    const request = create(ListTeamMembersRequestSchema, {
      pagination: {
        pageSize: 1,
      },
    });
    const response = await ona.services.team.listTeamMembers(request);
    console.log(response);
  }

  main().catch(console.error);
  ```

  ```go Go theme={null}
  package main

  import (
  	"context"
  	"fmt"
  	"log"

  	"connectrpc.com/connect"
  	"github.com/gitpod-io/gitpod-sdk-go/sdk"
  	gitpodpb "github.com/gitpod-io/gitpod-sdk-go/v1"
  )

  func main() {
  	ona, err := sdk.NewFromEnv()
  	if err != nil {
  		log.Fatal(err)
  	}

  	request := connect.NewRequest(&gitpodpb.ListTeamMembersRequest{
  		Pagination: &gitpodpb.PaginationRequest{
  			PageSize: 1,
  		},
  	})
  	response, err := ona.Services.Team.ListTeamMembers(context.Background(), request)
  	if err != nil {
  		log.Fatal(err)
  	}
  	fmt.Println(response.Msg)
  }
  ```

  ```json Request body theme={null}
  {
    "pagination": {
      "pageSize": 1
    }
  }
  ```
</CodeGroup>

## Request

`gitpod.v1.ListTeamMembersRequest`

| Field        | Type                                                    | Required | Description                                                         |
| ------------ | ------------------------------------------------------- | -------- | ------------------------------------------------------------------- |
| `pagination` | [PaginationRequest](#type-gitpod-v1-pagination-request) | No       |                                                                     |
| `teamId`     | string                                                  | No       | Constraints: `string.uuid=true`.                                    |
| `count`      | [CountRequest](#type-gitpod-v1-count-request)           | No       | count controls whether the response includes a bounded total count. |

## Response

`gitpod.v1.ListTeamMembersResponse`

| Field        | Type                                                      | Required | Description                                                                                                                        |
| ------------ | --------------------------------------------------------- | -------- | ---------------------------------------------------------------------------------------------------------------------------------- |
| `pagination` | [PaginationResponse](#type-gitpod-v1-pagination-response) | No       |                                                                                                                                    |
| `members`    | array of [TeamMember](#type-gitpod-v1-team-member)        | No       |                                                                                                                                    |
| `count`      | [CountResponse](#type-gitpod-v1-count-response)           | No       | count is the bounded total count of matching team members, present only when requested via CountRequest.include on the first page. |

## Related types

<a id="type-gitpod-v1-count-request" />

<Accordion title="CountRequest">
  CountRequest controls whether the response should include a bounded
  count of matching records.

  `gitpod.v1.CountRequest`

  | Field     | Type    | Required | Description                                                                                                                                                               |
  | --------- | ------- | -------- | ------------------------------------------------------------------------------------------------------------------------------------------------------------------------- |
  | `include` | boolean | No       | When true, the first page of results will include a CountResponse with the bounded total. Subsequent pages (requests with a pagination token) will not contain the count. |
</Accordion>

<a id="type-gitpod-v1-count-response" />

<Accordion title="CountResponse">
  CountResponse represents a bounded count of matching records.
  When the actual count exceeds the counting limit, value is capped and
  relation is set to GREATER\_THAN\_OR\_EQUAL.

  `gitpod.v1.CountResponse`

  | Field      | Type                                                             | Required | Description                                                           |
  | ---------- | ---------------------------------------------------------------- | -------- | --------------------------------------------------------------------- |
  | `value`    | integer                                                          | No       | The count of matching records, capped at the server's counting limit. |
  | `relation` | [CountResponseRelation](#enum-gitpod-v1-count-response-relation) | No       | Indicates whether value is the exact total or a lower bound.          |
</Accordion>

<a id="type-gitpod-v1-pagination-request" />

<Accordion title="PaginationRequest">
  `gitpod.v1.PaginationRequest`

  | Field      | Type    | Required | Description                                                                                                                              |
  | ---------- | ------- | -------- | ---------------------------------------------------------------------------------------------------------------------------------------- |
  | `pageSize` | integer | No       | Page size is the maximum number of results to retrieve per page. Defaults to 25. Maximum 100. Constraints: `int32.gte=0, int32.lte=100`. |
  | `token`    | string  | No       | Token for the next set of results that was returned as next\_token of a PaginationResponse                                               |
</Accordion>

<a id="type-gitpod-v1-pagination-response" />

<Accordion title="PaginationResponse">
  `gitpod.v1.PaginationResponse`

  | Field       | Type   | Required | Description                                                                             |
  | ----------- | ------ | -------- | --------------------------------------------------------------------------------------- |
  | `nextToken` | string | No       | Token passed for retrieving the next set of results. Empty if there are no more results |
</Accordion>

<a id="type-gitpod-v1-team-member" />

<Accordion title="TeamMember">
  TeamMember represents a user's membership in a team.

  `gitpod.v1.TeamMember`

  | Field       | Type               | Required | Description                                                                 |
  | ----------- | ------------------ | -------- | --------------------------------------------------------------------------- |
  | `id`        | string             | No       | Unique identifier for the team membership. Constraints: `string.uuid=true`. |
  | `teamId`    | string             | No       | Constraints: `string.uuid=true`.                                            |
  | `userId`    | string             | No       | Constraints: `string.uuid=true`.                                            |
  | `createdAt` | RFC 3339 timestamp | No       |                                                                             |
  | `name`      | string             | No       | name is the user's display name, populated at query time.                   |
  | `avatarUrl` | string             | No       | avatar\_url is the user's avatar URL, populated at query time.              |
</Accordion>

<a id="enum-gitpod-v1-count-response-relation" />

<Accordion title="CountResponseRelation">
  | Value                                 | Number | Description                                                                  |
  | ------------------------------------- | -----: | ---------------------------------------------------------------------------- |
  | `COUNT_RESPONSE_RELATION_UNSPECIFIED` |      0 |                                                                              |
  | `COUNT_RESPONSE_RELATION_EQ`          |      1 | The count is equal to the number of matching records.                        |
  | `COUNT_RESPONSE_RELATION_GTE`         |      2 | The actual number of matching records is greater than or equal to the value. |
</Accordion>
